<?php

$file = trim(preg_replace("'[\\\\/]+'", "/", (dirname(__FILE__)."/lang/".LANGUAGE_ID."/component.php")));
__IncludeLang($file);

define("CLD_MARKSUN", 1);

/**
 *   . ,       
 *  CSS .
 */
define("CLD_MARKSATSUN", 2);

/**
 *   . ,      
 *   . -   .
 */
define("CLD_MONDAYS", 2);

/**
 *   . ,     
 *   HTML .    . - 
 *  .
 */
define("CLD_BREAKS", 8);
if (!class_exists('FranchiseCalendar')) {
	class FranchiseCalendar {
		
		var $change_days = "N";
		
		var $monthsRes = array();
		/**
		 *       .
		 * @var array
		 * @see addUDateHoliday(), addDateHoliday(), removeUDateLink(), 
		 * removeDateLink(), removedateHolidays()
		 * @access private
		 */
		var $dateHolidays = array();
		
		/**
		 *       .
		 * @var array
		 * @see addUDateTitle(), addDateTitle(), removeUDateTitle(), 
		 * removeDateTitle(), removedatePreHolidays()
		 * @access private
		 */
		var $datePreHolidays = array();
		
		/**
		 *       .
		 * @var array
		 * @see addUDateTitle(), addDateTitle(), removeUDateTitle(), 
		 * removeDateTitle(), removedatePreHolidays()
		 * @access private
		 */
		var $dateWorkdays = array();
		
		
		/**
		 * ,          
		 *  .      
		 *     $MONTHES  $DOWS.
		 * @var string
		 * @see setLang()
		 * @access private
		 */
		var $lng = true;
		var $showTitle= true;
		var $showYear= false;
		var $today = false;
		var $addMonthChange=false;
		
		/**
		 * ,     CSS 
		 * @var string
		 * @see setCssPrefix()
		 * @access private
		 */
		var $cssPrefix;
		
		/**
		 *   .     
		 *   CLD_*,    OR.
		 * @var int
		 * @see setOptions()
		 * @access private
		 */
		var $options = false;
		
		/**
		 * 
		 * @access public
		 * @param string $_lng ,       
		 *   .        
		 *    setLang().
		 * @param int $_options  ,    OR 
		 * (.  CLD_*).   ,   
		 *   setOptions().
		 * @param int $_cssPrefix ,     CSS . 
		 *           
		 * setCssPrefix().
		 * @see setLang(), setOptions(), setCssPrefix()
		 */
		function Calendar($_lng = 'ru', $_options = false, $_cssPrefix = '') {
			// global $DOWS;
			// if(!isset($DOWS[$_lng])) {
				// trigger_error("Undefined language was specified.", E_USER_WARNING);
				// return false;
			// }
			// $this->dows = $DOWS[$_lng];
			// $this->setLang($_lng);
			$this->setOptions($_options);
			$this->setCssPrefix($_cssPrefix);
		}
		
		function getMonthsRes() {
			return $this->monthsRes;
		}
		
		/**
		 *          .
		 * @param string $_lng  .     
		 *     $DOWS  $MONTHES. - 
		 *  .
		 * @return bool    ,     ,  
		 *  true  false.
		 */
		function setLang($_lng) {
			global $MONTHES;
			global $DOWS;
			if(isset($MONTHES[$_lng]) && isset($DOWS[$_lng])) {
				$this->lng = $_lng;
				return true;
			} else {
				trigger_error("Calendar language not defined: '".$_lng."'", 
					E_USER_WARNING);
				return false;
			}
		}
		
		/**
		 *   ,    OR 
		 * (.  CLD_*).
		 * @param string $_options ,    OR.
		 * @return void
		 * @example $clndr->setOptions(CLD_MONDAYS | CLD_MARKSATSUN)
		 */
		function setOptions($_options) {
			$this->options = $_options;
		}
		
		/**
		 *  ,     CSS .   
		 *  ,       .
		 * @param string $_cssPrefix  ,     
		 * CSS .
		 * @return void
		 */
		function setCssPrefix($_cssPrefix) {
			$this->cssPrefix = $_cssPrefix;
		}
		
		/**
		 *     .     , 
		 *   .
		 * @access public
		 * @param int $_date    Unix timestamp,    
		 *  .   ""  -  ,  
		 *   .
		 * @param string $_url 
		 * @return void
		 * @see addDateHoliday(), removeUDateLink(), removeDateLink(), 
		 * removedateHolidays()
		 */
		function addUDateHoliday($_date, $_title) {
			$d = getdate($_date);
			$curMonth = (int)$d["mon"];
			$curYear=$d["year"];	
			$d = mktime(0, 0, 0, $d["mon"], $d["mday"], $d["year"]);
			$this->dateHolidays[$d] = $_title;	
			$wDay=date("w",$d);			
			if($wDay==6)
			{
				if ($this->change_days=='N')
				{
					if(!$this->dateHolidays[$d-24*60*60] && !$this->datePreHolidays[$d-24*60*60] && !$this->dateWorkdays[$d-24*60*60])
					{	
						$this->dateHolidays[$d-24*60*60] = $_title;
						$newMonth=(int)date("m",$d-24*60*60);
						$newYear=(int)date("Y",$d-24*60*60);
						if($curMonth!=$newMonth && $curYear==$newYear)
						{	
							$this->genMonth($this->monthsRes[$newMonth]['DAY_START'], $newMonth, $curYear);
						}
						if(!$this->dateHolidays[$d-2*24*60*60] && !$this->datePreHolidays[$d-2*24*60*60] && !$this->dateWorkdays[$d-2*24*60*60])
						{
							$this->addUDatePreHoliday($d-2*24*60*60,$_title)	;
							$newMonth=(int)date("m",$d-2*24*60*60);
							$newYear=(int)date("Y",$d-2*24*60*60);
							if($curMonth!=$newMonth && $curYear==$newYear)
							{	
								$this->genMonth($this->monthsRes[$newMonth]['DAY_START'], $newMonth, $curYear);
							}
						}
					}
				}
				else
				{
					$this->dateHolidays[$d] = $_title;
					$this->addUDatePreHoliday($d-24*60*60,$_title);
				}
				
				
			}	
			elseif($wDay==0)
			{			
				if ($this->change_days=='N')
				{
					if(!$this->dateHolidays[$d+24*60*60] && !$this->datePreHolidays[$d+24*60*60] && !$this->dateWorkdays[$d+24*60*60])
					{
						$this->dateHolidays[$d+24*60*60] = $_title;
					}
				}
				else
				{
					$this->dateHolidays[$d] = $_title;
				}
			}
			else
			{			
				if(!$this->dateHolidays[$d-24*60*60] && !$this->datePreHolidays[$d-24*60*60] && !$this->dateWorkdays[$d-24*60*60])
				{
					$this->addUDatePreHoliday($d-24*60*60,$_title);
					$newMonth=(int)date("m",$d-24*60*60);
					$newYear=(int)date("Y",$d-24*60*60);
					if($curMonth!=$newMonth && $curYear==$newYear)
					{	
						$this->genMonth($this->monthsRes[$newMonth]['DAY_START'], $newMonth, $curYear);
					}
				}
			}
		}
		function addUToday($_date, $_title) {
			$d = getdate($_date);
			$curMonth = (int)$d["mon"];
			$curYear=$d["year"];	
			$d = mktime(0, 0, 0, $d["mon"], $d["mday"], $d["year"]);
			$this->today[$d] = $_title;			
		}
		
		/**
		 *     .   addUDateHoliday 
		 *  ,    .     
		 * ,   .
		 * @access public
		 * @param int $_day 
		 * @param int $_month 
		 * @param int $_year 
		 * @param string $_url 
		 * @see addUDateHoliday(), removeUDateLink(), removeDateLink(), 
		 * removedateHolidays()
		 */
		function addDateHoliday($_day, $_month, $_year, $_title) {
			$this->addUDateHoliday(mktime(0, 0, 0, $_month, $_day, $_year), $_title);
			return true;
		}
		
		function addToday($_day, $_month, $_year, $_title) {
			$this->addUToday(mktime(0, 0, 0, $_month, $_day, $_year), $_title);
			return true;
		}
		
		/**
		 *      (  ).
		 * @access public
		 * @param int $_date ,      ( 
		 *  ,   )
		 * @see addUDateHoliday(), addDateHoliday(), removeDateLink(), removedateHolidays()
		 * @return void
		 */
		function removeUDateHoliday($_date) {
			$d = gethate($_date);
			$d = mktime(0, 0, 0, $d["mon"], $d["mday"], $d["year"]);
			unset($this->dateHolidays[$d]);
		}
		
		/**
		 *      (  ).  
		 *  removeUDateLink  ,    . 
		 * @access public
		 * @param int $_day 
		 * @param int $_month 
		 * @param int $_year 
		 * @see addUDateHoliday(), addDateHoliday(), removeUDateLink(), removedateHolidays()
		 * @return void
		 */
		function removeDateHoliday($_day, $_month, $_year) {
			$this->removeUDateHoliday(mktime(0, 0, 0, $_month, $_day, $_year));
		}
		
		/**
		 *    .
		 * @access public
		 * @see addUDateHoliday(), addDateHoliday(), removeUDateLink(), removeDateLink()
		 * @return void
		 */
		function removeHolidays() {
			$this->dateHolidays = array();
		}
		
		/**
		 *     .     ,   
		 * .
		 * @access public
		 * @param int $_date    Unix timestamp,    
		 *  .   "" ,  ,  
		 *   .
		 * @param string $_title  
		 * @return void
		 */
		function addUDatePreHoliday($_date, $_title) {
			$d = getdate($_date);
			$d = mktime(0, 0, 0, $d["mon"], $d["mday"], $d["year"]);
			$this->datePreHolidays[$d] = $_title;
		}
		
		/**
		 *     .   addUDateTitle  
		 * ,    .
		 * @access public
		 * @param int $_day 
		 * @param int $_month 
		 * @param int $_year 
		 * @param string $_title  
		 * @return void
		 */
		function addDatePreHoliday($_day, $_month, $_year, $_title) {
			$this->addUDatePreHoliday(mktime(0, 0, 0, $_month, $_day, $_year), $_title);
		}
		
		/**
		 *      (  ).
		 * @access public
		 * @param int $_date ,      
		 * (  ,   )
		 * @return void
		 */
		function removeUDatePreHoliday($_date) {
			$d = getdate($_date);
			$d = mktime(0, 0, 0, $d["mon"], $d["mday"], $d["year"]);
			unset($this->datePreHolidays[$d]);
		}
		
		/**
		 *      (  ).  
		 *  removeUDateTitle  ,    .
		 * @access public
		 * @param int $_day 
		 * @param int $_month 
		 * @param int $_year 
		 * @return void
		 */
		function removeDatePreHoliday($_day, $_month, $_year) {
			$this->removeUDatePreHoliday(mktime(0, 0, 0, $_month, $_day, $_year));
		}
		
		/**
		 *    .
		 * @access public
		 * @return void
		 */
		function removePreHolidays() {
			$this->datePreHolidays = array();
		}	
		
		

		
		/**
		 *     .     ,   
		 * .
		 * @access public
		 * @param int $_date    Unix timestamp,    
		 *  .   "" ,  ,  
		 *   .
		 * @param string $_title  
		 * @return void
		 */
		function addUDateWorkday($_date, $_title) {
			$d = getdate($_date);
			$d = mktime(0, 0, 0, $d["mon"], $d["mday"], $d["year"]);
			$this->dateWorkdays[$d] = $_title;
		}
		
		/**
		 *     .   addUDateTitle  
		 * ,    .
		 * @access public
		 * @param int $_day 
		 * @param int $_month 
		 * @param int $_year 
		 * @param string $_title  
		 * @return void
		 */
		function addDateWorkday($_day, $_month, $_year, $_title) {
			$this->addUDateWorkday(mktime(0, 0, 0, $_month, $_day, $_year), $_title);
		}
		
		/**
		 *      (  ).
		 * @access public
		 * @param int $_date ,      
		 * (  ,   )
		 * @return void
		 */
		function removeUDateWorkday($_date) {
			$d = getdate($_date);
			$d = mktime(0, 0, 0, $d["mon"], $d["mday"], $d["year"]);
			unset($this->dateWorkdays[$d]);
		}
		
		/**
		 *      (  ).  
		 *  removeUDateTitle  ,    .
		 * @access public
		 * @param int $_day 
		 * @param int $_month 
		 * @param int $_year 
		 * @return void
		 */
		function removeDateWorkday($_day, $_month, $_year) {
			$this->removeUDateWorkday(mktime(0, 0, 0, $_month, $_day, $_year));
		}
		
		/**
		 *    .
		 * @access public
		 * @return void
		 */
		function removeWorkdays() {
			$this->dateWorkdays = array();
		}	
			
		/**
		 *  HTML    .     Unix 
		 * tiestamp.
		 * @access public
		 * @param int $_date ,    
		 * ,   Unix timestamp ( ,  , 
		 *   ; ,    - )
		 * @param bool $_mark ,     
		 * . -,    .
		 * @return string  HTML 
		 */
		function genUMonth($_date, $_mark = false) {
			$MONTHES = array(
				'en' => array('January', 'February', 'March', 'April', 'May', 'June', 
					'July', 'August', 'September', 'October', 'November', 'December'),
				'ru' => array(GetMessage("MONTH_1"), GetMessage("MONTH_2"), GetMessage("MONTH_3"), GetMessage("MONTH_4"), GetMessage("MONTH_5"),GetMessage("MONTH_6"), 
					GetMessage("MONTH_7"), GetMessage("MONTH_8"), GetMessage("MONTH_9"),GetMessage("MONTH_10"), GetMessage("MONTH_11"), GetMessage("MONTH_12"))
			);
			$DOWS = array(
					'en' => array('Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa'),
					'ru' => array(GetMessage("calend_su"), GetMessage("calend_mo"), GetMessage("calend_tu"), GetMessage("calend_we"), GetMessage("calend_th"), GetMessage("calend_fr"), GetMessage("calend_sa"))
			);
			$d = getdate($_date);
			$month = $d["mon"];
			$day = $d["mday"];
			$year = $d["year"];
			$wDay = date('w', mktime(0, 0, 0, $month, 1, $year));
			$curMonth=date("m");
			if($curMonth!=$month && $this->addMonthChange)
				$style=' style="display:none;"';
			else
				$style="";			
			$res[] = '<table border="0" cellspacing="1" cellpadding="0" class="'.
				$this->cssPrefix.'month" '.$style.' id="month'.$month.'">';		
			
			$monthes = (isset($MONTHES[$this->lng]))?
				$MONTHES[$this->lng]:date('F', $_date);		
			
			$dows = $DOWS[$this->lng];
			//print_r($DOWS);exit;
			// -   
			$left_t='';
			$right_t='';
			if ($this->showTitle)
			{	
				if (file_exists($_SERVER['DOCUMENT_ROOT'].'/bitrix/templates/'.SITE_TEMPLATE_ID.'/images/right_t.png'))
					$rightImg='/bitrix/templates/'.SITE_TEMPLATE_ID.'/images/right_t.png';
				else
					$rightImg='/bitrix/components/franchise/franchise.calendar/templates/.default/images/left_t.png';
				if (file_exists($_SERVER['DOCUMENT_ROOT'].'/bitrix/templates/'.SITE_TEMPLATE_ID.'/images/left_t.png'))
					$leftImg='/bitrix/templates/'.SITE_TEMPLATE_ID.'/images/left_t.png';
				else
					$leftImg='/bitrix/components/franchise/franchise.calendar/templates/.default/images/left_t.png';
				if($month!=1 && $this->addMonthChange)
					$left_t='<a class="left_t" href="javascript:void(0);" onClick="$(\'.month\').css(\'display\',\'none\');$(\'#month'.($month - 1).'\').css(\'display\',\'\');" rel="nofollow" title="'.$monthes[$month - 2].'"><img style="padding-bottom:2px" src="'.$leftImg.'" alt="<"/></a>';
				if($month!=12 && $this->addMonthChange)
					$right_t='<a class="right_t" href="javascript:void(0);" onClick="$(\'.month\').css(\'display\',\'none\');$(\'#month'.($month+1).'\').css(\'display\',\'\');" rel="nofollow" title="'.$monthes[$month].'"><img style="padding-bottom:2px" src="'.$rightImg.'" alt=">"/></a>';
				$tmpHeadr='<tr><td colspan="7" class="'.$this->cssPrefix.'montitle">'.$left_t.$monthes[$month - 1];
				if ($this->showYear)
					$tmpHeadr.=' '.$year;
				$tmpHeadr.=$right_t.'</td></tr>';
				$res[] = $tmpHeadr;
			}
			
			//   
			$mondayIsFirst = true;
			$markSat = ($this->options & CLD_MARKSATSUN);
			$markSun = ($this->options & CLD_MARKSUN) || 
				($this->options & CLD_MARKSATSUN);
			
			if($mondayIsFirst) {
				$sunday = array_shift($dows);
				array_push($dows, $sunday);
				$wDay = $wDay?($wDay - 1):6;
			}
			
			// -    
			$tmp = array();
			for($i = 0; $i < 7; $i++) {
				//    /    
				//  CSS 
				$weekEnd = (($i == 6) || ($i == 5))?'marked':'';
				//   CSS    
				$tmp[] = '<th class="glav-c '.$weekEnd.'">'.$dows[$i].'</th>';
			}
			
			// ,      HTML 
			$s = ($this->options & CLD_BREAKS)?"\n":'';
			$res[] = '<tr>'.implode($s, $tmp).'</tr>
			<tr class="line">	
						<td colspan="7">
						</td>
			</tr>';
			
			//        
			// 
			$spacesNum = $wDay;
			
			//    
			$tmp = '<tr>';
			for($i = 0; $i < $wDay; $i++) {
				$weekEnd = (($i == 6) || ($i == 5))?'marked':'';
				$tmp .= '<td>&nbsp;</td>';
			}
			$res[] = $tmp;
			
			//  
			$wcnt = 0;
			
			for($i = 1, $striper = $wDay % 2; $i <= date('t', $_date); 
				$i++, $striper = !$striper) {
				
				//   ,  
				$today = $_mark && ($i == $day);
				
				//  
				$d = mktime(0, 0, 0, $month, $i, $year);
				$dayClass='';
				$spanTitle="";
				$HolidaysSet = isset($this->dateHolidays[$d]);
				$PreHolidaysSet = isset($this->datePreHolidays[$d]);
				$WorkdaysSet = isset($this->dateWorkdays[$d]);
				$todaySet = isset($this->today[$d]);
				if($HolidaysSet) {
					$dayClass='red-c';
					$spanClass='datelink';
					$spanTitle=$this->dateHolidays[$d];				
				} elseif($PreHolidaysSet) {
					$dayClass='green-c';
					$spanClass='titleddate';
					$spanTitle = $this->datePreHolidays[$d];
				} elseif($WorkdaysSet) {
					$dayClass='white-c';
					$spanClass='titleddate';
					$spanTitle = $this->dateWorkdays[$d];
				}
				if($todaySet)
				{
					$dayClass.=' today';
					$spanTitle=$this->today[$d]." ".$spanTitle;
				}
				if($HolidaysSet || $PreHolidaysSet || $todaySet )
				{
					$dayCode = '<span class="'.$this->cssPrefix.$spanClass.'" title="'.$spanTitle.'">'.$i.'</span>';
				}
				else
					$dayCode = $i;
				//  $wDay      ,
				//     ,   
				$wDay = ($wDay + 1) % 7;
				// ,     / 
				$weekEnd = (($wDay == 6) || ($wDay == 0))?'marked':'';
				
				$res[] = '<td class="'.$dayClass.' '.$weekEnd.'">'.$dayCode.'</td>';
				if(!$wDay) {
					$res[] = '</tr><tr>';
					$wcnt++;
					$striper = true;
				}
			}
			
			//   
			$spacesNum = (7 - ($spacesNum + $i) % 7) % 7 + 1;
			$tmp = '';
			for($i = 0; $i < $spacesNum; $i++, $striper = !$striper) {
				$tmp .= '<td>&nbsp;</td>';
			}
			$res[] = $tmp.'</tr>';
			
			//       ,   
			//  6 
			/*if($wcnt < 5) {
				$res[] = '<tr><td class="'.$this->cssPrefix.
					'dark">&nbsp;</td><td class="'.$this->cssPrefix.
					'light">&nbsp;</td><td class="'.$this->cssPrefix.
					'dark">&nbsp;</td><td class="'.$this->cssPrefix.
					'light">&nbsp;</td><td class="'.$this->cssPrefix.
					'dark">&nbsp;</td><td class="'.$this->cssPrefix.
					'light">&nbsp;</td><td class="'.$this->cssPrefix.
					'dark">&nbsp;</td></tr>';
			}*/
			
			$res[] = '</table>';
			
			$this->monthsRes[$month]['HTML']=implode($s, $res);
			$this->monthsRes[$month]['DAY_START']=$day;
			//return implode($s, $res);
		}
		
		function genMonth($_day, $_month, $_year) {
			$this->genUMonth(mktime(0, 0, 0, $_month, is_numeric($_day)?$_day:1, $_year), is_numeric($_day)?true:false);
			//return $this->genUMonth(mktime(0, 0, 0, $_month, is_numeric($_day)?$_day:1, $_year), is_numeric($_day)?true:false);
		}
		
		function genUYear($_date, $_mark = false, $_width = 3) {
			$year = date('Y', $_date);
			$mMonth = date('n', $_date);
			
			$res[] = '<table border="0" cellspacing="0" cellpadding="10" class="'.
				$this->cssPrefix.'year">';
			$res[] = '<tr><th colspan="'.$_width.'" class="'.$this->cssPrefix.
				'yeartitle"><big>'.$year.'</big></th></tr>';
			$res[] = '<tr>';
			
			for($i = 1; $i <= 12; $i++) {
				if($mMonth == $i) {
					$monthHtml = $this->genUMonth($_date, $_mark);
				} else {
					$monthHtml = $this->genUMonth(mktime(0, 0, 0, $i, 1, $year));
				}
				$res[] = '<td valign="top" class="'.$this->cssPrefix.
					(($i % $_width)?'monthcell':'monthlastcell').'">'.$monthHtml.
					'</td>';
				if(!($i % $_width)) {
					$res[] = '</tr><tr>';
				}
			}
			
			$res[] = $tmp.'</tr>';
			$res[] = '</table>';
			
			// ,      HTML 
			$s = ($this->options & CLD_BREAKS)?"\n":'';
			return implode($s, $res);
		}

		function genYear($_day, $_month, $_year, $_mark = false, $_width = 3) {
			return $this->genUYear(mktime(0, 0, 0, is_numeric($_month)?$_month:1, 
			is_numeric($_day)?$_day:1, $_year), $_mark, $_width);
		}
	}
}
?>