<?if(!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED!==true)die();
function formatFileSize($bytes) 
{
	if (!is_numeric($bytes) || !$bytes) {
		return '';
	}
	if ($bytes >= 1000000000) {
		return round($bytes / 1000000000,2).' '.GetMessage("GB");
	}
	if ($bytes >= 1000000) {
		return round($bytes / 1000000,2).' '.GetMessage("MB");
	}
	return round($bytes / 1000,2). ' '.GetMessage("KB");
}

function human_plural_form($number, $titles)
{
    $cases = array (2, 0, 1, 1, 1, 2);
    return $number." ".$titles[ ($number%100 >4 && $number%100< 20)? 2 : $cases[min($number%10, 5)] ];
}
?>
<div class="news-detail">
	<?if($arParams["DISPLAY_PICTURE"]!="N" && is_array($arResult["DETAIL_PICTURE"])):?>
		<img class="detail_picture" border="0" src="<?=$arResult["DETAIL_PICTURE"]["SRC"]?>" width="<?=$arResult["DETAIL_PICTURE"]["WIDTH"]?>" height="<?=$arResult["DETAIL_PICTURE"]["HEIGHT"]?>" alt="<?=$arResult["DETAIL_PICTURE"]["ALT"]?>"  title="<?=$arResult["NAME"]?>" />
	<?endif?>
	<?if($arParams["DISPLAY_DATE"]!="N" && $arResult["DISPLAY_ACTIVE_FROM"]):?>
		<span class="news-date-time"><?=$arResult["DISPLAY_ACTIVE_FROM"]?></span>
	<?endif;?>
	<?if($arParams["DISPLAY_NAME"]!="N" && $arResult["NAME"]):?>
		<h3><?=$arResult["NAME"]?></h3>
	<?endif;?>
	<?if($arParams["DISPLAY_PREVIEW_TEXT"]!="N" && $arResult["FIELDS"]["PREVIEW_TEXT"]):?>
		<p><?=$arResult["FIELDS"]["PREVIEW_TEXT"];unset($arResult["FIELDS"]["PREVIEW_TEXT"]);?></p>
	<?endif;?>
	<?if($arResult["NAV_RESULT"]):?>
		<?if($arParams["DISPLAY_TOP_PAGER"]):?><?=$arResult["NAV_STRING"]?><br /><?endif;?>
		<?echo $arResult["NAV_TEXT"];?>
		<?if($arParams["DISPLAY_BOTTOM_PAGER"]):?><br /><?=$arResult["NAV_STRING"]?><?endif;?>
 	<?elseif(strlen($arResult["DETAIL_TEXT"])>0):?>
		<?echo $arResult["DETAIL_TEXT"];?>
 	<?else:?>
		<?echo $arResult["PREVIEW_TEXT"];?>
	<?endif?>
	<div style="clear:both"></div>
	<br />
	<?foreach($arResult["FIELDS"] as $code=>$value):?>
			<?=GetMessage("IBLOCK_FIELD_".$code)?>:&nbsp;<?=$value;?>
			<br />
	<?endforeach;?>
	<?foreach($arResult["DISPLAY_PROPERTIES"] as $pid=>$arProperty):?>
		<?if($pid!="FILE"):?>
			<?=$arProperty["NAME"]?>:&nbsp;
			<?if(is_array($arProperty["DISPLAY_VALUE"])):?>
				<?=implode("&nbsp;/&nbsp;", $arProperty["DISPLAY_VALUE"]);?>
			<?else:?>
				<?=$arProperty["DISPLAY_VALUE"];?>
			<?endif?>
			<br />
		<?endif?>
	<?endforeach;?>
	<?if (!empty($arResult["DISPLAY_PROPERTIES"]['FILE']["DISPLAY_VALUE"])):?>
		<div class="files-download">
			<?if(is_array($arResult["DISPLAY_PROPERTIES"]['FILE']["DISPLAY_VALUE"])) {
				$arFiles = $arResult["DISPLAY_PROPERTIES"]['FILE']["DISPLAY_VALUE"];
				$arFilesData = $arResult["DISPLAY_PROPERTIES"]['FILE']['FILE_VALUE'];
			}
			else {
				$arFiles = array('file');
				$arFilesData = array($arResult["DISPLAY_PROPERTIES"]['FILE']['FILE_VALUE']);
			}
			foreach($arFiles as $key=>$value):	
				if(!$arFilesData[$key]['DESCRIPTION'])
					$arFilesData[$key]['DESCRIPTION']=$arFilesData[$key]['ORIGINAL_NAME'];
				$ext=substr($arFilesData[$key]['SRC'], strrpos($arFilesData[$key]['SRC'], '.') + 1);
				if (file_exists($_SERVER['DOCUMENT_ROOT'].'/bitrix/redirect.php'))
					$fileLink = 'href="/bitrix/redirect.php?goto='.$arFilesData[$key]['SRC'].'&event1=file&event3='.$arFilesData[$key]['FILE_NAME'].'&event2=download"';
				else
					$fileLink = 'target="blank" href="'.$arFilesData[$key]['SRC'].'"';
				?>
				<div>
					<a class="<?=$ext?>" <?=$fileLink?> title="<?=GetMessage("DOWNLOAD")?> <?=$arFilesData[$key]['DESCRIPTION']?>">
						<span><?=GetMessage("DOWNLOAD")?> "<?=$arFilesData[$key]['DESCRIPTION']?>"</span>
						<i> 
							(<?=formatFileSize($arFilesData[$key]['FILE_SIZE'])?>, <?=$ext?>)
							<?if (CModule::IncludeModule("statistic")):
								$rs = CStatEvent::GetList(
									 ($by = "s_id"), 
										($order = "desc"), 
									 array(
											'EVENT1'=>"file",
											"EVENT1_EXACT_MATCH"=>"Y",
											'EVENT2'=>"download",
											"EVENT2_EXACT_MATCH"=>"Y",
											"EVENT3"=>$arFilesData[$key]['FILE_NAME'],
											"EVENT3_EXACT_MATCH"=>"Y"),
									 $is_filtered
									);
								echo GetMessage("DOWNLOAD_COUNT").human_plural_form($rs->SelectedRowsCount(), array(GetMessage("RAZ"),GetMessage("RAZA"),GetMessage("RAZ")));
							endif?>	
						</i>
					</a>
				</div>
			<?endforeach;?>
		</div>
	<?endif?>
	<br/>
	<?
	if(array_key_exists("USE_SHARE", $arParams) && $arParams["USE_SHARE"] == "Y")
	{
		?>
		<div class="news-detail-share">
			<noindex>
			<?
			$APPLICATION->IncludeComponent("bitrix:main.share", "", array(
					"HANDLERS" => $arParams["SHARE_HANDLERS"],
					"PAGE_URL" => $arResult["~DETAIL_PAGE_URL"],
					"PAGE_TITLE" => $arResult["~NAME"],
					"SHORTEN_URL_LOGIN" => $arParams["SHARE_SHORTEN_URL_LOGIN"],
					"SHORTEN_URL_KEY" => $arParams["SHARE_SHORTEN_URL_KEY"],
					"HIDE" => $arParams["SHARE_HIDE"],
				),
				$component,
				array("HIDE_ICONS" => "Y")
			);
			?>
			</noindex>
		</div>
		<?
	}
	?>
	<br/>
	<br/>
</div>
