<?if(!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED!==true)die();
function formatFileSize($bytes) 
{
	if (!is_numeric($bytes) || !$bytes) {
		return '';
	}
	if ($bytes >= 1000000000) {
		return round($bytes / 1000000000,2).' '.GetMessage("GB");
	}
	if ($bytes >= 1000000) {
		return round($bytes / 1000000,2).' '.GetMessage("MB");
	}
	return round($bytes / 1000,2). ' '.GetMessage("KB");
}
function human_plural_form($number, $titles)
{
    $cases = array (2, 0, 1, 1, 1, 2);
    return $number." ".$titles[ ($number%100 >4 && $number%100< 20)? 2 : $cases[min($number%10, 5)] ];
}
?>
<div class="news-list">
<?if($arParams["DISPLAY_TOP_PAGER"]):?>
	<?=$arResult["NAV_STRING"]?>
<?endif;?>
<?foreach($arResult["ITEMS"] as $arItem):?>
	<?
	$this->AddEditAction($arItem['ID'], $arItem['EDIT_LINK'], CIBlock::GetArrayByID($arItem["IBLOCK_ID"], "ELEMENT_EDIT"));
	$this->AddDeleteAction($arItem['ID'], $arItem['DELETE_LINK'], CIBlock::GetArrayByID($arItem["IBLOCK_ID"], "ELEMENT_DELETE"), array("CONFIRM" => GetMessage('CT_BNL_ELEMENT_DELETE_CONFIRM')));
	?>
	<div class="news-item" id="<?=$this->GetEditAreaId($arItem['ID']);?>">
		<?if($arParams["DISPLAY_PICTURE"]!="N" && is_array($arItem["PREVIEW_PICTURE"])):?>
			<a href="<?=$arItem["DETAIL_PAGE_URL"]?>" ><img class="preview_picture" border="0" src="<?=$arItem["PREVIEW_PICTURE"]["SRC"]?>" width="<?=$arItem["PREVIEW_PICTURE"]["WIDTH"]?>" height="<?=$arItem["PREVIEW_PICTURE"]["HEIGHT"]?>" alt="<?=$arItem["PREVIEW_PICTURE"]["ALT"]?>" title="<?=$arItem["NAME"]?>" style="float:left" /></a>
		<?endif?>
		<?if($arParams["DISPLAY_DATE"]!="N" && $arItem["DISPLAY_ACTIVE_FROM"]):?>
			<span class="news-date-time"><?echo $arItem["DISPLAY_ACTIVE_FROM"]?></span>
		<?endif?>
		<?if($arParams["DISPLAY_NAME"]!="N" && $arItem["NAME"]):?>
			<?if(!$arParams["HIDE_LINK_WHEN_NO_DETAIL"] || ($arItem["DETAIL_TEXT"] && $arResult["USER_HAVE_ACCESS"])):?>
				<span class="news_name" ><a href="<?echo $arItem["DETAIL_PAGE_URL"]?>"><?echo $arItem["NAME"]?></a></span>
			<?else:?>
				<span class="news_name" ><b><?echo $arItem["NAME"]?></b></span>
			<?endif;?>
		<?endif;?>
		<?if($arParams["DISPLAY_PREVIEW_TEXT"]!="N" && $arItem["PREVIEW_TEXT"]):?>
			<?echo $arItem["PREVIEW_TEXT"];?>
		<?endif;?>
		<?if($arParams["DISPLAY_PICTURE"]!="N" && is_array($arItem["PREVIEW_PICTURE"])):?>
			<div style="clear:both"></div>
		<?endif?>
		<?foreach($arItem["FIELDS"] as $code=>$value):?>
			<small>
			<?=GetMessage("IBLOCK_FIELD_".$code)?>:&nbsp;<?=$value;?>
			</small><br />
		<?endforeach;?>
		<?foreach($arItem["DISPLAY_PROPERTIES"] as $pid=>$arProperty):
				if($pid!="FILE"):?>
					<small>
					<?=$arProperty["NAME"]?>:&nbsp;
					<?if(is_array($arProperty["DISPLAY_VALUE"])):?>
						<?=implode("&nbsp;/&nbsp;", $arProperty["DISPLAY_VALUE"]);?>
					<?else:?>
						<?=$arProperty["DISPLAY_VALUE"];?>
					<?endif?>
					</small><br />
					<?endif;
				endforeach;?>
		<?if (!empty($arItem["DISPLAY_PROPERTIES"]['FILE']["DISPLAY_VALUE"])):?>
			<div class="files-download">
				<?if(is_array($arItem["DISPLAY_PROPERTIES"]['FILE']["DISPLAY_VALUE"])) {
					$arFiles = $arItem["DISPLAY_PROPERTIES"]['FILE']["DISPLAY_VALUE"];
					$arFilesData = $arItem["DISPLAY_PROPERTIES"]['FILE']['FILE_VALUE'];
				}
				else {
					$arFiles = array('file');
					$arFilesData = array($arItem["DISPLAY_PROPERTIES"]['FILE']['FILE_VALUE']);
				}
				foreach($arFiles as $key=>$value):	
					if(!$arFilesData[$key]['DESCRIPTION'])
						$arFilesData[$key]['DESCRIPTION']=$arFilesData[$key]['ORIGINAL_NAME'];
					$ext=substr($arFilesData[$key]['SRC'], strrpos($arFilesData[$key]['SRC'], '.') + 1);
					if (file_exists($_SERVER['DOCUMENT_ROOT'].'/bitrix/redirect.php'))
						$fileLink = 'href="/bitrix/redirect.php?goto='.$arFilesData[$key]['SRC'].'&event1=file&event3='.$arFilesData[$key]['FILE_NAME'].'&event2=download"';
					else
						$fileLink = 'target="blank" href="'.$arFilesData[$key]['SRC'].'"';
					?>
					<div>
						<a class="<?=$ext?>" <?=$fileLink?> title="<?=GetMessage("DOWNLOAD")?> <?=$arFilesData[$key]['DESCRIPTION']?>">
							<span><?=GetMessage("DOWNLOAD")?> "<?=$arFilesData[$key]['DESCRIPTION']?>"</span>
							<i> 
								(<?=formatFileSize($arFilesData[$key]['FILE_SIZE'])?>, <?=$ext?>)
							</i>
						</a>
					</div>
				<?endforeach;?>
			</div>
		<?endif?>
	</div>
<?endforeach;?>
<?if($arParams["DISPLAY_BOTTOM_PAGER"]):?>
	<br /><?=$arResult["NAV_STRING"]?>
<?endif;?>
</div>
