$(function(){

	//vars -----------
	g = {
		'body' : $('body')
	};

	//onload----------
    g.body.toggleClass('jsOff jsOn');

    //ui actions obj
    ui = {
        'btnDisable' : function( btn, flag ){
            var action = flag ? 'addClass' : 'removeClass';
            btn[action]('disabled').find('.btn_hdn').prop('disable', flag);
        }
    };

    //b-slider
    (function(){
        var bSlider = $('.b-slider');
        if( !bSlider.length || !$.fn.caroufredsel ) return false;
        var items = bSlider.find('.slider_item');

        bSlider.find('.slider_list' ).caroufredsel({
            auto: false,
            width: 686,
            responsive: true,
            circular: false,
            height: 290,
            items: 1,
            scroll: {
                fx: 'crossfade',
                pauseOnHover: true
            },
            next: bSlider.find('.nav_next'),
            prev: bSlider.find('.nav_prev'),
            pagination: {
                container: bSlider.find('.slider_paging'),
                anchorBuilder: function(nr, item) {
                    console.log(items.eq( nr -1 ).attr('class'))
                    return '<b class="'+items.eq( nr -1 ).attr('class').split(' ')[1]+'" ></b>';
                }
            }
        });
    })();

    //tabs
    (function(){
        var bTabs = $('.b-tabs');
        if( !bTabs.length ) return false;
        var tbodys = bTabs.find('.tabs_tbody'),
            theads = bTabs.find('.tabs_thead'),
            active = bTabs.find('.thead_active');

        bTabs.on('click', '.tabs_thead', function(){
            $(this).addClass('thead_active').siblings().removeClass('thead_active');
            tbodys.eq( $(this).index()).show().siblings().hide();
        });

        if( active.length ){
            tbodys.eq( active.index()).show().siblings().hide();
            return;
        }
        theads.eq( 0 ).addClass('thead_active' ).siblings().removeClass('thead_active');
        tbodys.eq( 0 ).show().siblings().hide();
    })();

    //.b-spoiler
    (function(){
        var bSpoiler = $('.b-spoiler');
        if( !bSpoiler.length ) return false;

        bSpoiler.each(function(){

            var t = $(this),
                trigger = t.find('.-dash'),
                body = t.find('.spoiler_content');

            t.hasClass('expanded') || body.hide();

            t.on('click','.-dash', function(e){
                if(t.hasClass('expanded') ){
                    body.slideUp(150);
                    t.removeClass('expanded');
                }else{
                    body.slideDown(150);
                    t.addClass('expanded');
                }
            });
        });

    })();

    //b-counter
    (function(){
        var bCounter = $('.b-counter');
        if( !bCounter.length ) return false;


            var rgx = /^\d+$/g,
                minus = bCounter.find('.counter_minus'),
                plus = bCounter.find('.counter_plus'),
                input = bCounter.find('.counter_val'),
                curVal = parseInt( input.val() ) || 0;

            minus.click(function(){
                if( curVal <= 0 ) return false;
                curVal--;
                input.val( curVal );
                return false;
            });
            plus.click(function(){
                if( curVal >= 999 ) return false;
                curVal++;
                input.val( curVal );
                return false;
            });
            input.change(function(){
                if( rgx.test($(this).val()) ){
                    curVal = $(this).val();
                    input.val( curVal );
                    return;
                }
                input.val( curVal );
            });
    })();


    //b-news
    (function(){
        var bNews = $('.b-news');
        if( !bNews.length ) return false;

        var heads = bNews.find('.news_cat'),
            tabs = bNews.find('.news_tab' ),
            check = heads.find('.active');

        bNews.on('click','.news_cat',function(){
            $(this ).addClass('active' ).siblings().removeClass('active');
            tabs.eq( $(this ).index() ).show().siblings().hide();
        });

        if( check.length ){
            tabs.eq( check.index() ).show().siblings().hide();
            return;
        }

        heads.eq( 0 ).addClass('active' ).siblings().removeClass('active');
        tabs.eq( 0 ).show().siblings().hide();
    })();

    //b-login
    (function(){
        var bLogin = $('.b-login');
        if( !bLogin.length ) return false;

        var trigger = bLogin.find('.login_in' ),
            form = bLogin.find('.login_popup-form' ),
            input = bLogin.find('.login_input' ),
            btn = bLogin.find('.login_submit' ),
            minlength = 2, timer;

        input.on('keyup',function(){
            clearInterval(timer);
            timer = setTimeout(function(){
                if( input.eq(0).val().length >= minlength && input.eq(1).val().length >= minlength ){
                    ui.btnDisable( btn, false );
                    return;
                }
                ui.btnDisable( btn, true );
            },200);
        });
        input.eq(0).keyup();

        trigger.on('click',function(e){
            e.stopPropagation();
            form.fadeIn(150);
            g.body.one('click',function(){ form.fadeOut(150) });
        });
        form.on('click',function(e){e.stopPropagation() });
        form.on('click','.login_close',function(){ form.fadeOut(150) });
    })();

    //b-sorting ( только для простых таблиц без вложенности и объедененных рядов/ячеек ): NOTREADY=(
    (function(){
        var bSorting = $('.b-sorting');
        if( !bSorting.length ) return false;

        var titles = bSorting.find('.sorting_title' ),
            rows = bSorting.find('.sorting_row' ),
            tbody = bSorting.find('tbody' ).eq(0),
            tds = rows.find('td' ),
            sort = (function(){
                var arr = [];

                titles.each(function( i ){
                    var type = $(this ).attr('data-value-type');

                    arr[i] = {
                        'type' : type,
                        'data' : (function(){
                            var a = [], b = [];
                            for( var j = i; j < tds.length; j+=titles.length ){
                                var val = tds.eq( j ).text();
                                a.push( tds.eq( j ).parents('.sorting_row' ).eq(0) );
                                b.push( type == 'text' ? val : parseInt(val.replace(' ','')) );
                            }
                            return { 'rows' : a, 'values' : b };
                        })()
                    };
                });
                return arr;
            })();

        bSorting.on('click','.sorting_title',function(){
            if( $(this ).hasClass('title_active') ) return false;
            var t = $(this ),
                index = t.index(),
                newHtml = '',
                newArr = sort[index].data.values;

            t.addClass('title_active' ).siblings().removeClass('title_active');
            newArr.sort();
            console.log(newArr);

            //sort[index]
            //tbody.html( newHtml );
        });

    })();


    //placeholder fix
    (function(){
        $.fn.iePlaceholderFix = function(){
            if( document.createElement('input').placeholder !== undefined ) return false;
            return this.each(function(){
                var t = $(this), placeholder = t.attr('placeholder'), val = t.val();
                val || t.val( placeholder );
                t.focus(function(){
                    if( !t.val() || t.val() == placeholder ) t.val('').addClass( 'edited' );
                }).blur(function(){
                    if( !t.val() ) t.val( placeholder ).removeClass( 'edited' );
                }).parents( 'form' ).eq(0).submit(function(){
                    if( t.val() == placeholder ) t.val( val );
                });
            });
        };
        $('input[placeholder]').iePlaceholderFix(); //можно поставить более быстрый селектор
    })();

    //btns for IE
    (function(){
        if( !document.all ) return false;
        var bBtn = $('.b-btn');
        if( !bBtn.length ) return false;

        function cancelSelect(){ return false }

        bBtn.on('mousedown', '.btn_text', function(e){
            e.stopPropagation();
            e.preventDefault();
            var t = $(this).addClass('active').on('mousemove',cancelSelect);
            $(document).one('mouseup', function(){
               t.removeClass('active').off('mousemove',cancelSelect);
            });
        });

    })();

    //ie fix
    (function(){
        if( !document.all ) return false;
        if( !document.querySelector ){ //ie7
            var ugc = $('.ugc');

            ugc.find('img[style*=left]' ).addClass('ieLeft');
            ugc.find('img[style*=right]' ).addClass('ieRight');
        }
    })();
   
});